#ifndef OPENCL_FFT_H
#define OPENCL_FFT_H

#include <CL/cl.h>

#ifdef HAVE_AMD_FFT
#include <clFFT.h>
#endif

#ifdef HAVE_APPLE_FFT
#include <oclfft/clFFT.h>
#endif

#include "utilities.h"

typedef bool (*OclBenchmarkFunc) (cl_context context, cl_command_queue queue, 
								  cl_mem dev_mem, cl_mem dev_out_mem,
								  int n_dims, size_t *dims, int n_runs, Timer *timer);

double sum_of_absolute_differences (float *a, float *b, int n, bool scale);
void loop_data_opencl (const char *vendor,
			           OclBenchmarkFunc func,
			           cl_context context,
			           cl_command_queue *queues,
			           int n_devices,
			           OutputType outputType,
			           TimeEntry *time_entries);
bool compute_amd_fft (cl_context context,
			          cl_command_queue queue,
			          cl_mem dev_mem,
			          cl_mem out_mem,
			          int n_dims,
			          size_t *dims,
			          int n_runs,
			          Timer *timer);
bool compute_apple_fft (cl_context context,
			            cl_command_queue queue,
			            cl_mem dev_mem,
			            cl_mem out_mem,
			            int n_dims,
			            size_t *dims,
			            int n_runs,
			            Timer *timer);

#endif